#!/usr/bin/perl
#
#     html     htick. Version 1.00.
# Copyright by FreeSide. 2:5020/12000.20@FidoNet
#	       		    24:1/20@LinuxNet
#
# :
# ./htick_html.pl > <_.html>
#

use Time::Local;

my %areaq;
my %areas;
my %linkq;
my %links;

my $cur_size;
my $totals = 0;
my $totalq = 0;

#   htick
$logname = "/var/log/ftn/htick.log";

#    
$station = "FreeSide Mail Server";

#  
$version = "1.00";


#
sub date_to_period
{
    $_[0] =~ /(\d\d)\s(\w\w\w)\s(\d\d)/i; ($day, $month, $year) = ($1, $2, $3);
    timelocal("59", "59", "23", $day, $months{$month}, $year);
}


#  
open(LOG, "<$logname") || die "can't open $logname: $!";
while (<LOG>)
{
    if (/-{10}\s+\w+\s(.*),/)
    {
        $last = $1;
        if (!$from) {
            $found = date_to_period($1);
            $date ||= $found;
            $from = $1 if ($found >= $date);
    }
        next;
}

    if ($from)
    {
        if (/size: (\d+) area: (\S+) from: (\S+)/) {
            $totals += $1;
            $totalq++;
            $cur_size = $1;
            $areaq{"\U$2"}++;
            $areas{"\U$2"} += $cur_size;
            $linkq{$3}++;
            $links{$3} += $cur_size;
    }
}

}
close LOG || die "Can't close $logname: $!";;

#  .  ,    ;)
unless(%areas) {
    print "No files in areas or wrong period! Bad logfile.\n";
    exit;
}

# Begin HTML Code
print "
<html>
<head>
<meta http-equiv=\"Content-Language\" content=\"ru\">
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=koi8-r\">
<meta name=\"Author\" Content=\"FreeSide\">
<title> [     $station ] </title>
</head>
<body bgcolor=black>
<center>
<font size=4px color=yellow>    $station  $from  $last.</font>
</center><br>
<table border=0 width=100% borderColor=#CFCFFF>
<tr bgcolor=#575797><td width=50%><center><b><font color=#CFCFFF> </font></b></center></td><td width=25%><center><b><font color=#CFCFFF>- </font></b></center></td><td width=25%><center><b><font color=#CFCFFF></font></b></center></td></tr>
";

foreach (sort (keys %areaq)) {
print "<tr bgcolor=#E9B914><td width=50%><b>$_</b></td> <td width=25%>$areaq{$_}</td> <td width=25%><b>$areas{$_}</b></td></tr>";
}
print "</table>";

{
  my $totala = keys(%areaq);
  my $totall = keys(%linkq);

  print "<br><center><font color=yellow> <font color=red>$totals</font>   <font color=red>$totalq</font> ";
  print "  <font color=red>$totala</font>    <font color=red>$totall</font> .<font></center>";
  print "<center><font color=yellow>FreeSide`s HTick HTML Statistic Generator. Version <b>$version</b>.</font></center>";
  print "</body></html>";
}
